* window.c (window_internal_width): New function, which accounts
[bpt/emacs.git] / make-dist
1 #!/bin/sh
2
3 #### make-dist: create an Emacs distribution tar file from the current
4 #### source tree. This basically creates a duplicate directory
5 #### structure, and then hard links into it only those files that should
6 #### be distributed. This means that if you add a file with an odd name,
7 #### you should make sure that this script will include it.
8
9 progname="$0"
10
11 ### Exit if a command fails.
12 ### set -e
13
14 ### Print out each line we read, for debugging's sake.
15 ### set -v
16
17 clean_up=yes
18 make_tar=yes
19 newer=""
20
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 ## This option tells make-dist not to delete the staging directory
24 ## after it's done making the tar file.
25 "--no-clean-up" )
26 clean_up=no
27 ;;
28 ## This option tells make-dist not to make a tar file. Since it's
29 ## rather pointless to build the whole staging directory and then
30 ## nuke it, using this option also selects '--no-clean-up'.
31 "--no-tar" )
32 make_tar=no
33 clean_up=no
34 ;;
35 ## This option tells make-dist to make the distribution normally, then
36 ## remove all files newer than the given timestamp file. This is useful
37 ## for creating incremental or patch distributions
38 "--newer")
39 newer="$2"
40 new_extension=".new"
41 shift
42 ;;
43 * )
44 echo "${progname}: Unrecognized argument: $1" >&2
45 exit 1
46 ;;
47 esac
48 shift
49 done
50
51 ### Make sure we're running in the right place.
52 if [ ! -d src -o ! -f src/lisp.h -o ! -d lisp -o ! -f lisp/version.el ]; then
53 echo "${progname}: Can't find \`src/lisp.h' and \`lisp/version.el'." >&2
54 echo "${progname} must be run in the top directory of the Emacs" >&2
55 echo "distribution tree. Cd to that directory and try again." >&2
56 exit 1
57 fi
58
59 ### Find out which version of Emacs this is.
60 version=`grep 'defconst[ ]*emacs-version' lisp/version.el \
61 | sed -e 's/^.*"\([0-9][0-9]*\.[0-9][0-9]*\)\..*$/\1/'`
62 if [ ! "${version}" ]; then
63 echo "${progname}: can't find current emacs version in \`./lisp/version.el'." >&2
64 exit 1
65 fi
66
67 ### Make sure the subdirectory is available.
68 tempparent="make-dist.tmp.$$"
69 if [ -d ${tempparent} ]; then
70 echo "${progname}: staging directory \`${tempparent}' already exists.
71 Perhaps a previous invocation of \`${progname}' failed to clean up after
72 itself. Check that directories whose names are of the form
73 \`make-dist.tmp.NNNNN' don't contain any important information, remove
74 them, and try again." >&2
75 exit 1
76 fi
77
78 echo "Creating staging directory: \`${tempparent}'"
79 mkdir ${tempparent}
80 emacsname="emacs-${version}${new_extension}"
81 tempdir="${tempparent}/${emacsname}"
82
83 ### This trap ensures that the staging directory will be cleaned up even
84 ### when the script is interrupted in mid-career.
85 if [ "${clean_up}" = yes ]; then
86 trap "echo 'Interrupted...cleaning up the staging directory.'; rm -rf ${tempparent}; exit 1" 1 2 15
87 fi
88
89 echo "Creating top directory: \`${tempdir}'"
90 mkdir ${tempdir}
91
92 ### We copy in the top-level files before creating the subdirectories in
93 ### hopes that this will make the top-level files appear first in the
94 ### tar file; this means that people can start reading the INSTALL and
95 ### README while the rest of the tar file is still unpacking. Whoopee.
96 echo "Making links to top-level files."
97 ln GETTING.GNU.SOFTWARE INSTALL PROBLEMS README move-if-change ${tempdir}
98 ln ChangeLog Makefile.in build-install.in configure ${tempdir}
99 ln make-dist ${tempdir}
100 ### Copy config.sub; it's a cross-filesystem symlink.
101 cp config.sub ${tempdir}
102
103 echo "Creating subdirectories."
104 for subdir in lisp lisp/term local-lisp external-lisp \
105 src src/m src/s lib-src oldXMenu \
106 etc lock cpp info man shortnames vms; do
107 mkdir ${tempdir}/${subdir}
108 done
109
110 echo "Making links to \`lisp'."
111 ### Don't distribute =*.el files, site-init.el, site-load.el, or default.el.
112 (cd lisp
113 ln [a-zA-Z]*.el ../${tempdir}/lisp
114 ln [a-zA-Z]*.elc ../${tempdir}/lisp
115 ## simula.el doesn't keep abbreviations in simula.defns any more.
116 ## ln [a-zA-Z]*.defns ../${tempdir}/lisp
117 ln ChangeLog README ../${tempdir}/lisp
118 cd ../${tempdir}/lisp
119 rm -f site-init site-init.el site-init.elc
120 rm -f site-load site-load.el site-load.elc
121 rm -f default default.el default.elc)
122
123 echo "Making links to \`lisp/term'."
124 ### Don't distribute =*.el files.
125 (cd lisp/term
126 ln [a-zA-Z]*.el ../../${tempdir}/lisp/term
127 ln [a-zA-Z]*.elc ../../${tempdir}/lisp/term
128 ln README ../../${tempdir}/lisp/term)
129
130 echo "Making links to \`external-lisp'."
131 ### Don't distribute =*.el files.
132 (cd external-lisp
133 ln [a-zA-Z]*.el ../${tempdir}/external-lisp
134 ln [a-zA-Z]*.elc ../${tempdir}/external-lisp
135 ln ChangeLog README ../${tempdir}/external-lisp)
136
137 echo "Making links to \`src'."
138 ### Don't distribute =*.[ch] files, or the configured versions of
139 ### config.h.in, paths.h.in, or Makefile.in.
140 (cd src
141 echo " (If we can't link gmalloc.c, that's okay.)"
142 ln [a-zA-Z]*.c ../${tempdir}/src
143 ## Might be a symlink to a file on another filesystem.
144 cp gmalloc.c ../${tempdir}/src
145 ln [a-zA-Z]*.h ../${tempdir}/src
146 ln [a-zA-Z]*.s ../${tempdir}/src
147 ln README Makefile.in ymakefile ChangeLog config.h.in paths.h.in \
148 ../${tempdir}/src
149 ln .gdbinit .dbxinit ../${tempdir}/src
150 ln *.opt vms-pp.trans ../${tempdir}/src
151 cd ../${tempdir}/src
152 rm -f config.h paths.h Makefile
153 if [ -z "${newer}" ]; then
154 etags *.h *.c ../lisp/*.el
155 fi)
156
157 echo "Making links to \`src/m'."
158 (cd src/m
159 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/m)
160
161 echo "Making links to \`src/s'."
162 (cd src/s
163 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/s)
164
165 echo "Making links to \`lib-src'."
166 (cd lib-src
167 ln [a-zA-Z]*.[chy] [a-zA-Z]*.lex [a-zA-Z]*.com ../${tempdir}/lib-src
168 ln ChangeLog Makefile.in README testfile vcdiff rcs2log ../${tempdir}/lib-src
169 ln emacs.csh ../${tempdir}/lib-src
170 cd ../${tempdir}/lib-src
171 rm -f getdate.c getdate.tab.c y.tab.c y.tab.h)
172
173 echo "Making links to \`oldXMenu'."
174 (cd oldXMenu
175 ln *.c *.h ../${tempdir}/oldXMenu
176 ln README Makefile Imakefile ChangeLog ../${tempdir}/oldXMenu)
177
178 echo "Making links to \`etc'."
179 ### Don't distribute DOC files, backups, autosaves, or tex litter.
180 (cd etc
181 ln [0-9a-zA-Z]* ../${tempdir}/etc
182 cd ../${tempdir}/etc
183 ## Avoid an error when expanding the wildcards later.
184 for dummy in DOC-dummy dummy~ \#dummy\# dummy.dvi dummy.log; do
185 ln MACHINES ${dummy}
186 done
187 rm -f DOC* *~ \#*\# *.dvi *.log core)
188
189 ### For now, we comment these out, since I'm not changing them any.
190 ###!! echo "Making links to \`cpp'."
191 ###!! (cd cpp
192 ###!! ln cccp.c cexp.y Makefile README ../${tempdir}/cpp)
193 ###!!
194 ###!! echo "Making links to \`info'."
195 ###!! # Don't distribute backups or autosaves.
196 ###!! (cd info
197 ###!! ln [a-zA-Z]* ../${tempdir}/info
198 ###!! cd ../${tempdir}/info
199 ###!! # Avoid an error when expanding the wildcards later.
200 ###!! ln emacs dummy~ ; ln emacs \#dummy\#
201 ###!! rm -f *~ \#*\# core)
202 ###!!
203 ###!! echo "Making links to \`man'."
204 ###!! (cd man
205 ###!! ln *.tex *.texinfo *.texi *.aux *.cps *.fns *.kys *.vrs ../${tempdir}/man
206 ###!! ln *.c ../${tempdir}/man
207 ###!! ln ChangeLog Makefile README split-man ../${tempdir}/man)
208
209 echo "Making links to \`shortnames'."
210 (cd shortnames
211 ln *.c ../${tempdir}/shortnames
212 ln Makefile reserved special ../${tempdir}/shortnames)
213
214 echo "Making links to \`vms'."
215 (cd vms
216 ln [0-9a-zA-Z]* ../${tempdir}/vms
217 cd ../${tempdir}/vms
218 rm -f *~)
219
220 ### It would be nice if they could all be symlinks to etc's copy, but
221 ### you're not supposed to have any symlinks in distribution tar files.
222 echo "Making sure copying notices are all copies of \`etc/COPYING'."
223 rm -f ${tempdir}/etc/COPYING
224 cp etc/COPYING ${tempdir}/etc/COPYING
225 for subdir in lisp external-lisp src lib-src info shortnames; do
226 if [ -f ${tempdir}/${subdir}/COPYING ]; then
227 rm ${tempdir}/${subdir}/COPYING
228 fi
229 cp ../etc/COPYING ${tempdir}/${subdir}
230 done
231
232 if [ "${newer}" ]; then
233 echo "Removing files older than $newer."
234 ## We remove .elc files unconditionally, on the theory that anyone picking
235 ## up an incremental distribution already has a running Emacs to byte-compile
236 ## them with.
237 find ${tempparent} \( -name '*.elc' -o ! -newer ${newer} \) -exec rm -f {} \;
238 fi
239
240 if [ "${make_tar}" = yes ]; then
241 echo "Creating tar file."
242 (cd ${tempparent}; tar cvf - ${emacsname}) | compress > ${emacsname}.tar.Z
243 fi
244
245 if [ "${clean_up}" = yes ]; then
246 echo "Cleaning up the staging directory."
247 rm -rf ${tempparent}
248 fi
249
250 ### make-dist ends here